'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _index = require('./index');

var _index2 = _interopRequireDefault(_index);

var _lib = require('./lib');

var _middlewares = require('./middlewares');

var _middlewares2 = _interopRequireDefault(_middlewares);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Router = function () {
  function Router() {
    _classCallCheck(this, Router);
  }

  _createClass(Router, [{
    key: 'setControllersPath',
    value: function setControllersPath(path) {
      this.controllersPath = path;
    }
  }, {
    key: 'routes',
    value: function routes(rootPath, _routes) {
      this.rootPath = rootPath;
      this.routesArray = _routes;
    }
  }, {
    key: 'route',
    value: function route(req, res) {
      var _this = this;

      var url = req.url,
          method = req.method;


      this.routesArray.map(function (route) {
        route.method = route.method.toUpperCase();

        var response = new _index.Response(res);

        var run = function run() {
          if (route.middleWares && !route.action) {
            return (0, _middlewares2.default)(route.middleWares);
          } else if (route.middleWares && route.action) {
            throw new Error('params: action and middleWares cannot work together');
          }

          if ((url + '/' === '' + _this.rootPath + route.path || url === '' + _this.rootPath + route.path) && method === route.method) {
            var _route$action$split = route.action.split('@'),
                _route$action$split2 = _slicedToArray(_route$action$split, 2),
                name = _route$action$split2[0],
                action = _route$action$split2[1];

            _this.actionName = action;
            _this.controllerName = name;
            var Controller = void 0;

            try {
              Controller = new (require(_this.controllersPath + '/' + name).default)();
            } catch (e) {
              try {
                Controller = new (require(_this.controllersPath + '/' + name))();
              } catch (e) {
                throw new Error((0, _lib.capitalize)(_this.controllerName) + ' controller contains error or cannot find "' + _this.controllersPath + '/' + name + '" in ' + _index2.default.get('base'));
              }
            }

            _this.action(req, res, Controller[action].bind(Controller), response);
          }
        };

        if (route.guard) return route.guard({ req: req, res: res, next: run, response: response });

        run();
      });
    }
  }, {
    key: 'action',
    value: function action(req, res, method, response) {
      method({ req: req, res: res, response: response });
    }
  }]);

  return Router;
}();

Router.displayName = 'Router';
exports.default = new Router();