'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (req, res) {
  var status = res.statusCode;
  var statusCode = void 0;

  var paint = function paint(word, color) {
    word = word.toString();

    switch (color) {
      case 'red':
        return '\x1B[31m' + word + '\x1B[39m';
      case 'green':
        return '\x1B[32m' + word + '\x1B[39m';
      case 'cyan':
        return '\x1B[36m' + word + '\x1B[39m';
      case 'magenta':
        return '\x1B[35m' + word + '\x1B[39m';
      case 'bold':
        return '\x1B[1m' + word + '\x1B[22m';
      case 'bgWhite':
        return '\x1B[47m' + word + '\x1B[49m';
      case 'black':
        return '\x1B[30m' + word + '\x1B[39m';
    }
  };

  if (status >= 200 && status <= 226) statusCode = paint(status, 'green');
  if (status >= 300 && status <= 307) statusCode = paint(status, 'cyan');
  if (status >= 400 && status <= 451) statusCode = paint(status, 'red');
  if (status >= 500 && status <= 511) statusCode = paint(status, 'red');

  if (req.method.length === 3) {
    console.info(paint(' ', 'magenta') + paint(paint(req.method, 'bold'), 'magenta') + paint('    ', 'magenta') + paint(statusCode, 'bold') + ' ' + paint(' ', 'bgWhite') + paint(paint(req.url, 'black'), 'bgWhite') + paint(' ', 'bgWhite'));
  } else if (req.method.length === 4) {
    console.info(paint(' ', 'magenta') + paint(paint(req.method, 'bold'), 'magenta') + paint('   ', 'magenta') + paint(statusCode, 'bold') + ' ' + paint(' ', 'bgWhite') + paint(paint(req.url, 'black'), 'bgWhite') + paint(' ', 'bgWhite'));
  } else {
    console.info(paint(' ', 'magenta') + paint(paint(req.method, 'bold'), 'magenta') + paint(' ', 'magenta') + paint(statusCode, 'bold') + ' ' + paint(' ', 'bgWhite') + paint(paint(req.url, 'black'), 'bgWhite') + paint(' ', 'bgWhite'));
  }
};