import { pick, omit, isObject } from './lib';

export default class Controller {

  filterMode = 'omit';
  filter;

  bindMethods(array) {
    array.map(method => {
      this[method] = this['can'].bind(this);
    });
  }

  filtrate(target) {
    if (!target) return false;
    if (!isObject(target)) {
      throw new Error(`method "filtrate" in "BaseController" gets only object`);
    }
    let {filter, filterMode} = this;
    if (!filter) return target;

    switch (filterMode) {

      case 'omit':
        if (target.length > 0) {
          return target.map(target => {
            return omit(target, filter);
          });
        } else {
          return omit(target, filter);
        }

      case 'pick':
        if (target.length > 0) {
          return target.map(target => {
            return pick(target, filter);
          });
        } else {
          return pick(target, filter);
        }

    }
  }

}
