import isArray from '../array/isArray';
import isString from '../string/isString';
import isObject from './isObject';

/**
 *
 * @name pick
 * @param data {object}
 * @param rules {string} or {array}
 * @returns {array}
 *
 * @example pick({ user: 'zxc', pass: 'secret' }, 'pass') // returns ['zxc']
 * @example pick({ user: 'zxc', pass: 'secret' }, ['pass']) // returns ['zxc']
 *
 * @description if element not found, pick returns @param data
 * @copyright Vladimir Sentiurin 2017
 */

export default (data, rules) => {
  if (isObject(data)) {
    let keys = Object.keys(data);
    let picked = {};

    if (isArray(rules)) {
      keys.map(key => {
        rules.map(rule => {
          if (key === rule) picked[key] = data[key];
        });
      });
    } else if (isString(rules)) {
      keys.map(key => {
        if (key === rules) picked[key] = data[key];
      });
    }

    return picked;
  } else {
    throw new Error(`first argument "${data}" must be object in pick function`);
  }
};
